(** Generated by coq-of-ocaml *)
Require Import CoqOfOCaml.CoqOfOCaml.
Require Import CoqOfOCaml.Settings.

Require Import TezosOfOCaml.Proto_demo.Environment.
Import Environment.Notations.
Require TezosOfOCaml.Proto_demo.Bootstrap_storage.
Require TezosOfOCaml.Proto_demo.Commitment_storage.
Require TezosOfOCaml.Proto_demo.Contract_storage.
Require TezosOfOCaml.Proto_demo.Parameters_repr.
Require TezosOfOCaml.Proto_demo.Raw_context.
Require TezosOfOCaml.Proto_demo.Roll_storage.
Require TezosOfOCaml.Proto_demo.Script_repr.
Require TezosOfOCaml.Proto_demo.Seed_storage.
Require TezosOfOCaml.Proto_demo.Storage_mli. Module Storage := Storage_mli.
Require TezosOfOCaml.Proto_demo.Vote_storage.

Definition prepare_first_block
  (ctxt : Context.t)
  (typecheck :
    Raw_context.t -> Script_repr.t ->
    Lwt.t
      (Error_monad.tzresult
        ((Script_repr.t * option Contract_storage.big_map_diff) * Raw_context.t)))
  (level : int32) (timestamp : Time.t) (fitness : (|Fitness|).(S.T.t))
  : Lwt.t (Error_monad.tzresult Raw_context.t) :=
  let=? '(previous_protocol, ctxt) :=
    Raw_context.prepare_first_block level timestamp fitness ctxt in
  let=? ctxt := Storage.Big_map.Next.init_with_default_value ctxt in
  match previous_protocol with
  | Raw_context.Genesis param =>
    let=? ctxt :=
      Commitment_storage.init ctxt param.(Parameters_repr.t.commitments) in
    let=? ctxt := Roll_storage.init ctxt in
    let=? ctxt := Seed_storage.init ctxt in
    let=? ctxt := Contract_storage.init ctxt in
    let=? ctxt :=
      Bootstrap_storage.init ctxt typecheck
        param.(Parameters_repr.t.security_deposit_ramp_up_cycles)
        param.(Parameters_repr.t.no_reward_cycles)
        param.(Parameters_repr.t.bootstrap_accounts)
        param.(Parameters_repr.t.bootstrap_contracts) in
    let=? ctxt := Roll_storage.init_first_cycles ctxt in
    let=? ctxt := Vote_storage.init ctxt in
    let=? ctxt := Storage.Block_priority.init ctxt 0 in
    let=? ctxt := Vote_storage.freeze_listings ctxt in
    Error_monad.__return ctxt
  | Raw_context.Alpha_previous => Error_monad.__return ctxt
  end.

Definition prepare
  (ctxt : Context.t) (level : Int32.t) (predecessor_timestamp : Time.t)
  (timestamp : Time.t) (fitness : (|Fitness|).(S.T.t))
  : Lwt.t (Error_monad.tzresult Raw_context.context) :=
  Raw_context.prepare level predecessor_timestamp timestamp fitness ctxt.
